//    WeIRCd IRC server software - sub file
//    Copyright (C) 2007, 2008 Jonas Thiem
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.

#define LINKTYPE_LISTENER 3 //special link type which contains a listener for other passive ones

// -- CONFIGURATION DATA
struct weircd_linkdata {//config data for wanted links (nothing to do from the actually established ones
	int type;
	unsigned char* target;//only needed for active links
	int port;
	unsigned char* password;
	unsigned char* protocol;
};

// -- ACTUAL LINKS DATA
#define MAXPASSIVELINKS 50
struct weircd_passivelink {//actually opened listener sockets (passive links)
	int port;
	unsigned char* password;
	unsigned char* protocol;
	int islistener;
	unsigned char ip[17];//if it's not a listener but a running established link with a client
	int socket;
	unsigned long long connecttime;
};
struct weircd_passivelink* plinks[MAXPASSIVELINKS];
#define MAXACTIVELINKS 50
struct weircd_activelink {//actually opened listener sockets (passive links)
	int port;
	int disconnected;//if 1 then we are currently (completely) disconnected
	long disconnecttime;//used for reconnects later
	unsigned char* password;
	unsigned char* target;
	unsigned char* protocol;
	int socket;
	int tcp;
};
struct weircd_activelink* alinks[MAXACTIVELINKS];

int cTcp = -1; //current tcp environment, -1 indicates testing/no environment [WRAPPER]

void weircdLinksInit();
void links_checkListeners(int startup);
void links_checkActive(int startup);
void activelinks_processconnect(int aid);
void linkwrapper_environment(int tcp);
int newpassiveconnection(int listener, const unsigned char* ip);
void sendonlink(const unsigned char* stuff,int user);
void sendalllinks(const unsigned char* stuff);
void sendalllinks_exception(const unsigned char* stuff, int exception);
void sendtoservid(const unsigned char* stuff,int id);
void sendtoservname(const unsigned char* name,const unsigned char* stuff);
void sendontcp(const unsigned char* stuff,int tcp);
void telllinksaboutserver(int tcp, const unsigned char* name, const unsigned char* linkedto, int hops, const unsigned char* description);

