//    WeIRCd IRC server software - sub file
//    Copyright (C) 2007, 2008 Jonas Thiem
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.

void links_servers_unflag() {
	int r = 0;
	while (r < MAXLINKS) {
		if (linkstcp[r] != NULL) {
			linkstcp[r]->flagged = false;
		}
		r++;
	}
}

void links_users_servclear() {
	int r = 0;
	while (r < MAXSERVS) {
		svnames[r] = NULL;
		r++;
	}
}
int links_users_servid(const unsigned char* servname) {
	int r = 0;
	while (r < MAXSERVS) {
		if (svnames[r] != NULL) {
			if (strcasecmp(svnames[r],servname) == 0) {
				return r;
			}
		}
		r++;
	}
	return -1;
}
void links_servers_flagwithuser(int uid) {
	if (up[uid]->hopcount <= 0) {return;}
	int r = links_users_servid(up[uid]->servname);
	if (r < 0) {return;}
	linkstcp[svtcp[r]]->flagged = true;
}
void links_servers_flagusersofchan(int chan) {
	links_servers_unflag();
	int r = 0;
	while (r < userslotcount) {
		if (up[r] != NULL) {
			if (isuserinchan(r,chan) == true) {
				links_servers_flagwithuser(r);
			}
		}
		r++;
	}
}
int links_users_servexists(const unsigned char* servname) {
	if (strcasecmp(servname,cuo.svd) == 0) {return 0;}
	int r = 0;
	while (r < MAXSERVS) {
		if (svnames[r] != NULL) {
			if (strcasecmp(svnames[r],servname) == 0) {
				return 0;
			}
		}
		r++;
	}
	return -1;
}
void links_users_delserv(const unsigned char* servname) {
	int r = 0;
	while (r < MAXSERVS) {
		if (svnames[r] != NULL) {
			if (strcasecmp(svnames[r],servname) == 0) {
				int k = 0;
				while (k < COMPILEOPTION_MAXUSERS) {
					if (userpointers[k] != NULL) {
						if (userpointers[k]->authed == true && userpointers[k]->hopcount > 0) {
							if (strcasecmp(userpointers[k]->servname,servname) == 0) {
								userQuit(k,USERQUIT_NETSPLIT);
							}
						}
					}
					k++;
				}
				removeemptychans();
				k = 0;
				while (k < COMPILEOPTION_MAXCHANS) {
					if (chans[k] != NULL) {
						if (chans[k]->hopcount > 0) {
							if (strcasecmp(chans[k]->servname,servname) == 0) {
								netsplitchan(k);
							}
						}
					}
					k++;
				}
				if (svlinked[r] != NULL) {free(svlinked[r]);svlinked[r] = NULL;}
				free(svdesc[r]);
				svdesc[r] = NULL;
				free(svnames[r]);
				svnames[r] = NULL;
				return;
			}
		}
		r++;
	}
}

//--> collect all servers that need to get deleted <--
unsigned char delservbuf[1600] = "";int delservcount;
void links_users_delservers_init() {
	strcpy(delservbuf,"delserver");delservcount = 0;
}
void links_users_delservers_add(const unsigned char* name) {
	strncat(delservbuf," ",1599);delservbuf[1599] = 0;
	strncat(delservbuf,name,1599);delservbuf[1599] = 0;
	delservcount++;
}
const unsigned char* links_users_delservers_get() {
	return delservbuf;
}
//--> end of collecting all servers that need to get deleted <--

void links_users_deltcp(int tcp) {
	links_users_delservers_init();
	int r = 0;
	while (r < MAXSERVS) {
		if (svnames[r] != NULL) {
			if (svtcp[r] == tcp) {
				links_users_delservers_add(svnames[r]);
				links_users_delserv(svnames[r]);
			}
		}
		r++;
	}
}
int links_users_addserv(const unsigned char* servname, int tcp, int hop, const unsigned char* linkedto, const unsigned char* desc) {
	unsigned char lclserv[500];
	strncpy(lclserv,servname,499);lclserv[499] = 0;
	trimleft(lclserv);trimright(lclserv);
	printf("ADDSERV: %s %d %s :%s\n",servname,hop,linkedto,desc);
	if (strlen(lclserv) <= 1 || charpos(lclserv,' ') > 0 || strlen(lclserv) > 80 || charpos(lclserv,'!') > 0) {printf("addserv: invalid serv name\n");return -1;}
	if (links_users_servexists(lclserv) == 0) {printf("addserv: server is known\n");return -1;}
	int r = 0;
	while (r < MAXSERVS) {
		if (svnames[r] == NULL) {
			svlinked[r] = NULL;
			svnames[r] = malloc(strlen(lclserv)+1);
			if (svnames[r] == NULL) {return -1;}
			strcpy(svnames[r],lclserv);
			if (linkedto != NULL) {
				svlinked[r] = malloc(strlen(linkedto)+1);
				if (svlinked[r] == NULL) {free(svnames[r]);svnames[r]= NULL;return -1;}
				strcpy(svlinked[r],linkedto);
			}
			svdesc[r] = malloc(strlen(desc)+1);
			if (svdesc[r] == NULL) {
				free(svnames[r]);svnames[r] = NULL;
				if (svlinked[r] != NULL) {free(svlinked[r]);svlinked[r] = NULL;}
				return -1;
			}
			strcpy(svdesc[r],desc);
			svtcp[r] = tcp;
			svhop[r] = hop;
			printf("addserv: server %s is added (TCP: %d)\n",servname,svtcp[r]);
			telllinksaboutserver(svtcp[r], svnames[r], linkedto, svhop[r], svdesc[r]);
			return 0;
		}
		r++;
	}
	printf("addserv: all slots FULL!!\n");
	return -1;
}
void links_users_add(const unsigned char* nickname, const unsigned char* servername) {
	int k = links_users_servid(servername);
	if (k < 0) {printf("Failed to add %s: Server %s not found\n",nickname,servername);return;}
	int r = 0;
	while (r < COMPILEOPTION_MAXUSERS) {
		if (userpointers[r] == NULL) {
			userpointers[r] = malloc(sizeof(struct weircd_user));
			if (userpointers[r] == NULL) {
				printf("add remote user %s: memory allocation failed!!!\n",nickname);
				return;
			}
			memset(userpointers[r], 0, sizeof(struct weircd_user));
			userpointers[r]->servname = svnames[k];
			userpointers[r]->linktcpdata = svtcp[k];
			userpointers[r]->hopcount = svhop[k];
			userpointers[r]->authed = true;
			userpointers[r]->sendbeforeremove = false;
			up[r]->pleaseremove = false;
			userpointers[r]->ircop = false;
			/*if (charpos(modes,'o') > 0) {
				userpointers[r]->ircop = true;
			}*/
			userpointers[r]->quitreason = NULL;
			if (r >= userslotcount) {userslotcount = r+1;}
			strncpy(userpointers[r]->nickname,nickname,COMPILEOPTION_MAXNICKLEN);
			userpointers[r]->nickname[COMPILEOPTION_MAXNICKLEN] = 0;
			strcpy(userpointers[r]->suserid,"0");
			strcpy(userpointers[r]->realname,"0");
			strcpy(userpointers[r]->host,"0");
			//printf("user %s created on %s with tcp %d\n",nickname,servername,svtcp[k]);
			return;
		}
		r += 1;
	}
	return;
}
void links_chans_del(int id) {
	//remove all users which are still inside
	int r = 0;
	while (r < COMPILEOPTION_MAXUSERS) {
		if (up[r] != NULL) {
			if (up[r]->pleaseremove == 0 && up[r]->authed == true) {
				int k = 0;
				while (k < COMPILEOPTION_MAXCHANSPERUSER) {
					if (up[r]->chan[k] != NULL) {
						if (up[r]->chan[k]->chanid == id) {
							free(up[r]->chan[k]);up[r]->chan[k] = NULL;
						}
					}
					k++;
				}
			}
		}
		r++;
	}
	free(chans[id]);
	chans[id] = NULL;
}
void links_chans_add(const unsigned char* channame, const unsigned char* servername) {
	unsigned char send[512];
	int k = links_users_servid(servername);
	if (k < 0) {printf("Failed to add %s: Server %s not found\n",channame,servername);return;}
	int r = 0;
	r = getChanID(channame);
	if (r >= 0) {printf("Failed to add %s: Chan already exists!\n",channame);return;}
	r = 0;
	while (r < COMPILEOPTION_MAXCHANS) {
		if (chans[r] == NULL) {
			chans[r] = malloc(sizeof(struct weircd_channel));
			if (userpointers[r] == NULL) {
				printf("add remote channel %s: memory allocation failed!!!\n",channame);
				return;
			}
			memset(userpointers[r], 0, sizeof(struct weircd_channel));
			chans[r]->hopcount = svhop[k];
			chans[r]->linktcpdata = svtcp[k];
			chans[r]->servname = svnames[k];
			strncpy(chans[r]->name,channame,MAXCHANNELNAMELEN);
			chans[r]->name[MAXCHANNELNAMELEN] = 0;
			printf("channel %s created on %s with tcp %d\n",channame,servername,svtcp[k]);
			if (chans[r]->hopcount > 0) {
				//introduce all our local users
				int j = 0;
				while (j < userslotcount) {
					if (up[j] != NULL) {
						if (up[j]->pleaseremove == 0 && up[j]->authed == true) {
							if (isuserinchan(j,r) == true) {
								snprintf(send,511,":%s!%s@%s JOIN %s",up[j]->nickname,up[j]->suserid,up[j]->host,chans[r]->name);
								send[511] = 0;
								sendontcp(send,svtcp[k]);
							}
						}
					}
					j++;
				}
			}
			return;
		}
		r += 1;
	}
	return;
}

