//    WeIRCd IRC server software - sub file
//    Copyright (C) 2007, 2008 Jonas Thiem
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.

#define MAXMOTDLEN 500
unsigned char* motdline[MAXMOTDLEN];
int motd_cleared = 0;
int lcount = 0;
void motd_clear() {
	lcount = 0;
	int r = 0;
	while (r < MAXMOTDLEN) {
		motdline[r] = NULL;
		r++;
	}
}
void unload_motd() {
	lcount = 0;
	if (motd_cleared == 0) {motd_clear();motd_cleared = 1;return;}
	int r = 0;
	while (r < MAXMOTDLEN) {
		if (motdline[r] != NULL) {free(motdline[r]);}
		r++;
	}
}
int motd_load(const unsigned char* path) {	
	unload_motd();
	FILE *r;
	r = fopen(path,"r");
	if (!r) {
		return -1;
	}
	unsigned char line[300];int c = 0;
	while (fgets(line, 300, r) != NULL && c < MAXMOTDLEN) {
		line[299] = 0;
		if (strendswith(line,"\r\n") == 0) {line[strlen(line)-2] = 0;}
		if (strendswith(line,"\n") == 0) {line[strlen(line)-1] = 0;}
		motdline[c] = malloc(strlen(line)+1);
		if (motdline[c] == NULL) {unload_motd();return -1;}
		lcount += 1;
		strcpy(motdline[c],line);
		c++;
	}
	fclose(r);
	return 0;
}
void motd_send(int userid) {
	if (motd_cleared == 0) {motd_clear();motd_cleared = 1;}
	if (lcount <= 0) {
		usnd(userid,":%s 422 %s :No MOTD file.",cuo.svd,un(userid));
		return;
	}	
	usnd(userid,":%s 375 %s :- %s Message of the Day",cuo.svd,un(userid),cuo.svd);
	int r = 0;
	while (r < lcount) {
		if (motdline[r] != NULL) {
			usnd(userid,":%s 372 %s :- %s",cuo.svd,un(userid),motdline[r]);
		}
		r++;
	}
	usnd(userid,":%s 376 %s :End of /MOTD.",cuo.svd,un(userid),cuo.svd);
}

