//    WeIRCd IRC server software - sub file
//    Copyright (C) 2007, 2008 Jonas Thiem
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.

void listeners_init() {
	int r = 0;
	while (r < SOCKCOUNT) {
		mastersocket[r] = -1;
		socketport[r] = 0;
		r++;
	}
}
int listeners_getfreesock() {
	int r = 0;
	while (r < SOCKCOUNT) {
		if (mastersocket[r] < 0) {return r;}
		r++;
	}
	return -1;
}
void listeners_close(int nr) {
	int r = 0;
	while (r < COMPILEOPTION_MAXUSERS) {
		if (userpointers[r] != NULL) {
			if (userpointers[r]->mastersocketid == nr && userpointers[r]->pleaseremove == 0) {
				if (userpointers[r]->socketunselected == 0) {
					userpointers[r]->socketunselected = 1;
					FD_CLR(userpointers[r]->socket,&socketset);
				}
				userQuit(r,USERQUIT_LINKCLOSE);
			}else{
				if (userpointers[r]->mastersocketid == nr) {//find all those users quitting but still on the send queue
					if (userpointers[r]->socketunselected == 0) {
						userpointers[r]->socketunselected = 1;
						FD_CLR(userpointers[r]->socket,&socketset);
					}
					userpointers[r]->sendbeforeremove = 0;//no no, you don't get send anything - we are closing down your listener port, sorry
				}
			}
		}
		r++;
	}
	clearusers();//force to get rid of all those users NOW which
	            //closes all their sockets when their ressources are freed
	recalculatenfds();
	FD_CLR(mastersocket[nr],&socketset);
	close(mastersocket[nr]);
	mastersocket[nr] = -1;
}
int listeners_getbyport(int port) {
	int r = 0;
	while (r < SOCKCOUNT) {
		if (mastersocket[r] >= 0 && socketport[r] == port) {return r;}
		r++;
	}
	return -1;
}

int listener_add(const unsigned char* vbind,int port, int startup) {
	int sid = listeners_getfreesock();
#ifdef IPV6
	struct sockaddr_in6 masteraddress;
#endif
#ifndef IPV6
	struct sockaddr_in masteraddress;
#endif
	int addrlen = sizeof (masteraddress);
	const int lclyes = 1;
	memset(&masteraddress, 0, sizeof(masteraddress));
	if (startup == 1) {
		printf("%s    > Opening port %d\n",startupprefixsub,port);
	}
	if (sid < 0) {
		if (startup == 1) {
			printf("%s          -Warning: Socket limit\n",startupprefixsub);
			printf("%s            reached!\n",startupprefixsub);
		}
		return -1;
	}
	if ((mastersocket[sid] = socket(AINET, SOCK_STREAM, 0)) <= 0) {
		if (startup == 1) {
			printf("%s          -Warning: Was not able\n",startupprefixsub);
			printf("%s            to get a socket!\n",startupprefixsub);
		}else{
		
		}
		mastersocket[sid] = -1;
		return -1;
	}
	masteraddress.fam = AINET;
	if (strcasecmp(vbind,"any") != 0) {
#ifndef WIN
		inet_pton(AINET, vbind, &(masteraddress.add));
#ifndef IPV6
		if (masteraddress.sadd == ADD_ANY || masteraddress.sadd == ADD_NONE) {
#endif
#ifdef IPV6
		if (IN6_IS_ADDR_UNSPECIFIED(&masteraddress.sadd) == 1) {// || masteraddress.sadd == ADD_ANY) {
#endif
#endif
#ifdef WIN
#ifdef IPV6
#error IPv6 support for windows is not available yet
		if (1 == 1) {
#endif
#ifndef IPV6
		masteraddress.sin_addr.s_addr = inet_addr(vbind);
		if (masteraddress.sin_addr.s_addr == INADDR_NONE || masteraddress.sin_addr.s_addr == INADDR_ANY) {
#endif
		//TODO: provide windoZe ipv6 function here
#endif
		
			if (startup == 1) {
				printf("%s          -Warning: Setting socket\n",startupprefixsub);
				printf("%s            address to %s failed.\n",startupprefixsub,vbind);
			}
			mastersocket[sid] = -1;
			return -1;
		}
	}else{
		masteraddress.sadd = ADD_ANY;	
	}
		
	masteraddress.sport = htons(port);
#ifndef WIN
	setsockopt(mastersocket[sid], SOL_SOCKET,SO_REUSEADDR, &lclyes, sizeof(int));
#endif
	if (bind(mastersocket[sid],(struct sockaddr *) &masteraddress,sizeof (masteraddress)) < 0) {
		if (startup == 1) {
			printf("%s          -Warning: Binding to\n",startupprefixsub);
			if (strcasecmp(vbind,"any") != 0) {
				printf("%s            %s:%d failed!\n",startupprefixsub,vbind,port);
			}else{
				printf("%s            INADD_ANY:%d failed!\n",startupprefixsub,port);
			}
			return -1;
		}
		mastersocket[sid] = -1;
		return -1;
	}
	listen (mastersocket[sid], port);nfds++;
	FD_SET(mastersocket[sid],&socketset);
	setSocketNonblocking(mastersocket[sid]);
	socketport[sid] = port;
	return 0;
}
int listeners_count() {
	int r = 0;int k = 0;
	while (r < SOCKCOUNT) {
		if (mastersocket[r] >= 0) {
			k++;
		}
		r++;
	}
	return k;
}
void listeners_confsync(const unsigned char* bind, int startup) {
	int r,k,z;
	//first: open up new listeners (cycle through conf and find those which have no matching entry in the socket list)
	r = 0;
	while (r < MAXCONFBINDS) {
		if (cuo.bindport[r] > 0) {
			k = listeners_getbyport(cuo.bindport[r]);
			if (k < 0) {
				listener_add(bind,cuo.bindport[r],startup);
			}
		}
		r++;
	}
	//next: close unwanted ones (cycle through socket list and find those which have no matching conf entry
	r = 0;
	while (r < SOCKCOUNT) {
		if (mastersocket[r] >= 0) {
			k = 0;z = 0;
			while (k < MAXCONFBINDS) {
				if (cuo.bindport[k] == socketport[r]) {
					z = 1;
					break;
				}
				k++;
			}
			if (z == 0) {//no match, close it down:
				listeners_close(r);
			}
		}
		r++;
	}
}
