//    WeIRCd IRC server software - sub file
//    Copyright (C) 2007, 2008 Jonas Thiem
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.

void setSocketNonblocking(int socket) {
#ifndef WIN
	int save_fd;
	save_fd = fcntl(socket, F_GETFL);
	save_fd |= O_NONBLOCK;
	fcntl(socket, F_SETFL, save_fd);
#endif
#ifdef WIN
	long l = 1;
	ioctlsocket(socket,FIONBIO,&l);
#endif
}
int socketsStartup(const unsigned char* vbind) {
#ifdef WIN
	printf("%s Initialising winsock...\n",startupprefix);
	WSADATA wsa;
	long r = WSAStartup(MAKEWORD(2,0),&wsa);
	if (r != 0) {
		printf("%    > Was not able to start winsock system!\n",startupprefixsub);
		return -1;
	}
#endif
	printf("%s Starting listener sockets...\n",startupprefix);
	int sockcount = 0;
	listeners_init();
	listeners_confsync(vbind,1);
	if (listeners_count() <= 0) {
		printf("%s    > Failed to open the minimum\n",startupprefixsub);
		printf("%s       of 1 listener!\n",startupprefixsub);
		return -1;
	}
	return 0;
}
void checkNewClientsOnSock(int i) {
	int addrlen = sizeof (struct sockaddr_in);
#ifdef IPV6
	struct sockaddr_in6 address;
#endif
#ifndef IPV6
	struct sockaddr_in address;
#endif
	int new_socket,r;
	if (!FD_ISSET(mastersocket[i],cpy)) {return;}
	new_socket = accept(mastersocket[i],(struct sockaddr *) &address,&addrlen);
	if (new_socket > 0) {
		setSocketNonblocking(new_socket);
		r = userAdd(new_socket);
		if (r >= 0) {
			userpointers[r]->CONNECTtime = ts();

			// - COPY THE IP INTO A READABLE STRING FORMAT
			address.fam = AINET;
			int cnt = sizeof(userpointers[r]->ip);
#ifdef WIN // WINDOZE
#ifdef IPV6
			getnameinfo((struct sockaddr *)&address.add, sizeof(struct
sockaddr_in6), userpointers[r]->ip, cnt, NULL, 0, NI_NUMERICHOST);
#endif
#ifndef IPV6
			getnameinfo((struct sockaddr *)&address.add, sizeof(struct
sockaddr_in), userpointers[r]->ip, cnt, NULL, 0, NI_NUMERICHOST);
#endif
#endif

#ifndef WIN // LINUX/POSIX
			inet_ntop(AINET, &address.add, userpointers[r]->ip,sizeof(userpointers[r]->ip));
#endif
			#ifdef IPV6
			userpointers[r]->ip[INET6_ADDRSTRLEN] = 0;
			#endif
			#ifndef IPV6
			userpointers[r]->ip[16] = 0;
			#endif
			// - DONE (send Tribes some flowers)
			userpointers[r]->mastersocketid = i;
			strncpy(userpointers[r]->host,userpointers[r]->ip,COMPILEOPTION_MAXHOSTLEN);
			userpointers[r]->host[COMPILEOPTION_MAXHOSTLEN-1] = 0;
			unsigned char* gline = glinedbyip(userpointers[r]->ip,1);
			if (gline != NULL) {
				unsigned char snd[500];
				snprintf(snd,499,"ERROR: G-lined: %s",gline);
				snd[499] = 0;
				vsnd(snd,r);
				userQuit(r,USERQUIT_ERROR);
				return;
			}
			gline = glinedbyip(userpointers[r]->ip,0);
			if (gline != NULL) {
				unsigned char snd[500];
				snprintf(snd,499,"ERROR: K-lined: %s",gline);
				snd[499] = 0;
				vsnd(snd,r);
				userQuit(r,USERQUIT_ERROR);
				return;
			}
			if (clonesalarm(userpointers[r]->ip) == 1) {
				return;
			}
			if (connectthrottled(userpointers[r]->ip) == 1) {
				vsnd("ERROR :Throttled (Please wait 20 seconds until next reconnect)",r);
				userQuit(r,USERQUIT_ERROR);
				return;
			}
			sendStartup(r);
		}
	}
}
void checkNewClients() {
	int r = 0;
	while (r < SOCKCOUNT) {
		if (mastersocket[r] >= 0) {
			checkNewClientsOnSock(r);
		}
		r++;
	}
}
void ircproceed(int userid) {
	unsigned char lclstring[600];
	unsigned char lclstring2[600];
	strncpy(lclstring,userpointers[userid]->recvbuffer,599);
	lclstring[599] = 0;
	int r = 0;
	r = charpos(userpointers[userid]->recvbuffer,'\n');
	if (r >= 0) {
		cut(userpointers[userid]->recvbuffer,r + 1);
		if (r <= 599) {
			lclstring[r] = 0;
		}
	}
	userpointers[userid]->floodprotect.floodpoints += 1;
	trimleft(lclstring);
	allbehindchar(32,lclstring2,lclstring);
	allbeforechar(32,lclstring,lclstring);
	userCMD(userid,lclstring,lclstring2);
}
void receiveOnSocket(int userid) {
	if (userpointers[userid]->hopcount > 0) {return;}
	if (userpointers[userid]->floodprotect.floodpoints > 100) {return;}
	unsigned char lclbuffa[USER_RECVBUFFERSIZE + 1];
	int z;
	if (userpointers[userid]->socketunselected == 1) {return;}
	if (!FD_ISSET(uSocket(userid),cpy)) {return;}
	if (strlen(userpointers[userid]->recvbuffer) < USER_RECVBUFFERSIZE - 1) {
		int k = strlen(userpointers[userid]->recvbuffer);
		errno = 0;
		z = recv(uSocket(userid),lclbuffa,USER_RECVBUFFERSIZE - (k+1),0);
		if (z > 0) {
			//printf("RECEIVED SOMETHING!\n");
			lclbuffa[z] = 0;
			strcat(userpointers[userid]->recvbuffer,lclbuffa);
			k = k+z;
			z = 0;
			while (z < k) {
				if (userpointers[userid]->recvbuffer[z] == 0) {userpointers[userid]->recvbuffer[z] = 32;}
				z += 1;
			}
			z = 0;
			while (z < k-1) {
				if (userpointers[userid]->recvbuffer[z] == '\r') {
					userpointers[userid]->recvbuffer[z] = '\n';
					if (userpointers[userid]->recvbuffer[z+1] == '\n') {
						userpointers[userid]->recvbuffer[z+1] = 32;
					}
				}
				z += 1;
			}
			while (charpos(userpointers[userid]->recvbuffer,'\n') >= 0) {
				ircproceed(userid);
			}
			return;
		}else{
#ifdef WIN
			int err = WSAGetLastError();
			if ((err != WSAEWOULDBLOCK && err != WSAEINTR && err != WSAENOBUFS) || z == 0) {
#endif
#ifndef WIN
			if ((errno != EWOULDBLOCK && errno != EINTR && errno != EAGAIN && errno != ENOBUFS) || z == 0) {
#endif
				//printf("RECV:QUIT %d %d %d\n",USER_RECVBUFFERSIZE - (k+1),z,errno);
				if (userpointers[userid]->socketunselected == 0) {
					userpointers[userid]->socketunselected = 1;
					FD_CLR(userpointers[userid]->socket,&socketset);
					recalculatenfds();
				}
				userQuit(userid,USERQUIT_EOF);
			}
		}
	}else{
		strcpy(userpointers[userid]->recvbuffer,"");
		userpointers[userid]->floodprotect.floodpoints += 4;
	}
}
void recalculatenfds() {
	int r = 0;int k = 0;nfds = 0;
	while (r < COMPILEOPTION_MAXUSERS) {
		if (userpointers[r] != NULL) {
			if (userpointers[r]->socketunselected == 0 && userpointers[r]->hopcount <= 0) {
				k = userpointers[r]->socket;
				if (k >= nfds) {nfds = k+1;}
			}
		}
		r++;
	}
	r = 0;
	while (r < SOCKCOUNT) {
		if (mastersocket[r] >= nfds) {
			nfds = mastersocket[r]+1;
		}
		r++;
	}
	linkstcp_recalculatenfds();
}
void selectWait() {
	recalculatenfds();
	//if (cpy != NULL) {free(cpy);cpy = NULL;}
	struct timeval t;
	memset(&t,0,sizeof(struct timeval));
	t.tv_usec = 800000;
	if (cpy == NULL) {cpy = malloc(sizeof(socketset));}
	if (wcpy == NULL) {wcpy = malloc(sizeof(socketset));}
	memcpy(cpy,&socketset,sizeof(socketset));
	memcpy(wcpy,&socketset,sizeof(socketset));
	int r;
	if (wantsend > 0) {
		r = select(nfds,cpy,wcpy,NULL,&t);
	}else{
		r = select(nfds,cpy,NULL,NULL,&t);
		FD_ZERO(wcpy);
	}
	if (r <= 0) {FD_ZERO(cpy);FD_ZERO(wcpy);}
}
int sendOnSocket(int userid,const unsigned char* buffer,int buffsize) {
	errno = 0;
	if (userpointers[userid]->socketunselected == 1) {return;}
	if (!FD_ISSET(uSocket(userid),wcpy)) {return;}
	int retval = send(uSocket(userid),buffer,buffsize,0);//MSG_NOSIGNAL);
	if (retval > 0) {
		return retval;
	}else{
#ifdef WIN
		int err = WSAGetLastError();
		if ((err != WSAEWOULDBLOCK && err != WSAEINTR && err != WSAENOBUFS) || retval == 0) {
#endif
#ifndef WIN
		if ((errno != EWOULDBLOCK && errno != EINTR && errno != ENOBUFS) || retval == 0) {
#endif
			if (userpointers[userid]->socketunselected == 0) {
				userpointers[userid]->socketunselected = 1;
				FD_CLR(userpointers[userid]->socket,&socketset);
				recalculatenfds();
			}
			userQuit(userid,USERQUIT_EOF);
			return -1;
		}else{
			return 0;
		}
	}
}
void sendMeIfYouCan(int userid) {
	int k;
	if (userpointers[userid]->hopcount > 0) {return;}
	if (userpointers[userid]->socketunselected == 1) {return;}
	if (!FD_ISSET(uSocket(userid),wcpy)) {return;}
	if (userpointers[userid]->sendbuffer[0] != NULL) {
		k = sendOnSocket(userid,userpointers[userid]->sendbuffer[0],strlen(userpointers[userid]->sendbuffer[0]));
		if (k == strlen(userpointers[userid]->sendbuffer[0])) {
			scrollSendBuffer(userid);
		}else{
			if (k < 0) {return;}//something went wrong
			if (k > 0) {cut(userpointers[userid]->sendbuffer[0],k);}
		}
	}
}
void sendAll() {
	int i = 0;
	while (i < COMPILEOPTION_MAXUSERS) {
		if (userpointers[i] != NULL) {
			if (userpointers[i]->pleaseremove == false || userpointers[i]->sendbeforeremove == true) {
				sendMeIfYouCan(i);
			}
		}
		i += 1;
	}
}
void receiveAll() {
	int i = 0;
	while (i < COMPILEOPTION_MAXUSERS) {
		if (userpointers[i] != NULL) {
			if (userpointers[i]->pleaseremove == false && userpointers[i]->hopcount <= 0) {
				receiveOnSocket(i);//usleep(500);
			}
		}
		i += 1;
	}
}
